Right-Ctrl key broken on French OSS keyboard

Bug #1013881 reported by Emmanuel Castro on 2012-06-15
120
This bug affects 24 people
Affects Status Importance Assigned to Milestone
xkeyboard-config
Fix Released
Medium
xkeyboard-config (Ubuntu)
High
Bryce Harrington
Precise
High
Unassigned

Bug Description

Since the version 2.5-1ubuntu1.2 of the package xkb-data, the right CTRL key of the keyboard has ceased to work.
The problem started when APT has updated the xkd-data from 2.5-1ubuntu1 to 2.5-1ubuntu1.2.

If I switch back to 2.5.-1ubuntu1 using Synaptic, it works back.

ProblemType: Bug
DistroRelease: Ubuntu 12.04
Package: xkb-data 2.5-1ubuntu1
ProcVersionSignature: Ubuntu 3.2.0-25.40-generic 3.2.18
Uname: Linux 3.2.0-25-generic x86_64
ApportVersion: 2.0.1-0ubuntu9
Architecture: amd64
Date: Sat Jun 16 00:16:09 2012
Dependencies:

DistUpgraded: Fresh install
DistroCodename: precise
DistroVariant: ubuntu
InstallationMedia: Ubuntu 12.04 LTS "Precise Pangolin" - Release amd64 (20120425)
Lsusb:
 Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
 Bus 002 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
 Bus 001 Device 002: ID 8087:0024 Intel Corp. Integrated Rate Matching Hub
 Bus 002 Device 002: ID 8087:0024 Intel Corp. Integrated Rate Matching Hub
 Bus 002 Device 003: ID 17ef:1003 Lenovo Integrated Smart Card Reader
MachineType: LENOVO 4243E69
PackageArchitecture: all
ProcEnviron:
 TERM=xterm
 PATH=(custom, no user)
 LANG=fr_FR.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-3.2.0-25-generic root=UUID=f6981326-31fd-4eaf-b039-3a1e5f33dbc0 ro quiet splash vt.handoff=7
SourcePackage: xkeyboard-config
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 12/06/2011
dmi.bios.vendor: LENOVO
dmi.bios.version: 8AET56WW (1.36 )
dmi.board.asset.tag: Not Available
dmi.board.name: 4243E69
dmi.board.vendor: LENOVO
dmi.board.version: Not Available
dmi.chassis.asset.tag: No Asset Information
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Not Available
dmi.modalias: dmi:bvnLENOVO:bvr8AET56WW(1.36):bd12/06/2011:svnLENOVO:pn4243E69:pvrThinkPadT520:rvnLENOVO:rn4243E69:rvrNotAvailable:cvnLENOVO:ct10:cvrNotAvailable:
dmi.product.name: 4243E69
dmi.product.version: ThinkPad T520
dmi.sys.vendor: LENOVO
version.compiz: compiz 1:0.9.7.8-0ubuntu1
version.ia32-libs: ia32-libs 20090808ubuntu36
version.libdrm2: libdrm2 2.4.32-1ubuntu1
version.libgl1-mesa-dri: libgl1-mesa-dri 8.0.2-0ubuntu3.1
version.libgl1-mesa-dri-experimental: libgl1-mesa-dri-experimental N/A
version.libgl1-mesa-glx: libgl1-mesa-glx 8.0.2-0ubuntu3.1
version.xserver-xorg-core: xserver-xorg-core 2:1.11.4-0ubuntu10.2
version.xserver-xorg-input-evdev: xserver-xorg-input-evdev 1:2.7.0-0ubuntu1.2
version.xserver-xorg-video-ati: xserver-xorg-video-ati 1:6.14.99~git20111219.aacbd629-0ubuntu2
version.xserver-xorg-video-intel: xserver-xorg-video-intel 2:2.19.0-0ubuntu1~xup1
version.xserver-xorg-video-nouveau: xserver-xorg-video-nouveau 1:0.0.16+git20111201+b5534a1-1build2

Gnome default setup when Xorg keyboard is "fr"/"oss" leads to the "France Alternative" layout.

In this layout some application can't handle space caracter properly.
(See URL as some exemples).

Workaround is to force "France Alternative, latin9 only" in Gnome

or

change Xorg.conf replacing :

Option "XkbVariant" "oss"
by
Option "XkbVariant" "latin9"

Created attachment 16310
xorg.conf

First of all, GNOME represents whatever is in base.xml. There is default French layout and several variants (including "oss" and "oss_latin9"). User choses whatever he wants. So I am not really sure what is the essence of your complain.

From the user's point of view there was no choice made when installing Ubuntu 8.04 (just picked a French keyboard without knowing the underlying mechanism).
In the end some functions are altered.

According to what I understand (and I have no real knowledge of the process)

1- User install X => picks a keyboard
2- X is somehow configured with XkbdLayout and XkbdVariant in /etc/X11/xorg.conf
3- GNOME picks these value and reads the associated entries in /etc/X11/xkb/base.xml to use them as default.

Step 1 and 2 above => This is the responsability of the linux distribution to configure xorg.conf. In Ubuntu it seems that debconf is the xorg.conf creation tool (according to the comment). Is this tool responsible to pick "oss" instead of "latin9" ?

What do you think ?

Another idea here : Perhaps is it simply the "oss" variant that is faulty and does not behave as expected ?

(In that case it seems to trigger a "ctrl+space" when the user press "space")

This is actually distro-specific, xkeyboard-config has nothing to do with it. FWIW fr(oss) produces space when space is pressed.

Let's take the following assumptions :

1 - configure manually xorg.conf (no distro involved here) to put "fr" variant "oss"
2 - use GNOME who accurately detects "France Alternative"
3 - try to search something in Rhythmbox involving a "space" caracter.
4 - it fails as if "ctrl+space" was triggered instead of "space"

I'm just trying to figure where the bug is...

The point is as for now it actually seems to be in "oss" because of the manual configuration step.

How can we make sure ?

You can easily check. Try running xev utility and press space

Just made a check with xev.
Everything seems fine at xev level.

From xev point of view pressing space returns char 20 => which indeed is a space.

My latest idea about "oss" being the source of the problem is not the good one.

Did you try the configuration to reproduce the bug ?

That is :

=> xorg.conf such as the attachment I made
=> Set 'France Alternative' as default keyboard in GNOME.

then

launch rhythmbox and try to search with something including a space caracter.

> Everything seems fine at xev level.
It means XKB is not in charge. So, it is really not ours, as I expected.

> launch rhythmbox and try to search with something including a space caracter.
Tried. Works ok. But space is actually not entered into the search line - it triggers play/pause thing. Which I guess it the rhythmbox normal behaviour.

Sorry to reopen again this one.

The default behavior of Rhytmbox is not to start playing when space is entered. The real short cut for this is ctrl+space.

This is the faulty behaviour started it all.

As for now the workaround for this bug is to change xorg.conf parameters.

Shouldn't that be a xorg problem ? Where is this analysis bad ?

If you look in the URL I have included you may also see that the same problem occurs in Quod Libet and CodeBlocks. Meaning that it is not tightly linked to Rhytmbox. https://bugs.launchpad.net/xkeyboard-config/+bug/221112

I have no slightest idea. In all layouts I use (Russian, USA) space triggers play/pause in Rhythmbox. I suggest addressing further question to Rhythmbox developers. Both oss and latin9 define SPCE as space on first shift level. I suspect this is the issue with modifiers (Ctrl) handling in Rhythmbox (or GTK). But this is just my guess.

As seen on https://bugs.launchpad.net/xkeyboard-config/+bug/221112, a workaround is in "/etc/X11/xkb/symbols/fr" to replace this :
    include "nbsp(level4nl)"
by this :
    include "nbsp(level4n)"

Does that help ?

It also seems to be related to https://bugs.freedesktop.org/show_bug.cgi?id=9529

> Does that help ?

Do you ask me? Since you're reporter - it's up to you to make sure it works for you;)

From the user point of view (this is mine) it helps indeed.

Can this help to find a solution ?

I mean a solution suitable to everybody ... not only me :)

Actually this nbsp(level4nl) was offered by Nicolas. I think it would be good if you settle this issue (see bug #9529)

I don't have any magic solution:

1. if some apps misbehave when ctrl+space is used by the xkb layout they should be fixed by their upstream. xkb layouts are a fact of life which means apps have to deal with them gracefully

2. plus with multimedia keyboards so common nowadays almost every home keyboard will have a dedicated start/pause key, so trying to grab ctrl+space is not necessary

3. in the meanwhile you're free to try the other nbsp options. I made this key configurable for a reason — none of the options work well in every case so users are free to chose their lesser evil. When the other default were set other people complained for other reasons

Though the situation may get a bit better if someone took the time to figure why RControl and LControl are not defined by default in xkb. I used Control instead because I didn't want to risk side-effects by distinguishing between both control keys when the default layout didn't. If RControl and LControl were cleanly separated one of them would be left for apps to use with space.

Also depending on where in gtk the bug occur changing level4nl to

// level4nl provides narrow no-breaking space in addition to the normal one
// without forcing the use of level5 for mostly four-level layouts
// Used by fr(oss), be(oss)…
partial
xkb_symbols "level4nl" {
 key <SPCE> {
   type[Group1]="LOCAL_EIGHT_LEVEL",
   symbols[Group1]= [ space, space, NoSymbol, nobreakspace, NoSymbol, 0x100202F, NoSymbol, NoSymbol ]
 };
};

may limit the occurrence of such side-effects

I've just tried this latest configuration.
It doesn't change the behavior of the incriminated application but now no modifiers

Space key alone in xev :

KeyRelease event, serial 31, synthetic NO, window 0x2200001,
    root 0x13b, subw 0x0, time 550680493, (85,98), root:(1666,147),
    state 0x10, keycode 65 (keysym 0x20, space), same_screen YES,
    XLookupString gives 1 bytes: (20) " "
    XFilterEvent returns: False

Left control + space :

KeyPress event, serial 31, synthetic NO, window 0x2200001,
    root 0x13b, subw 0x0, time 550711435, (91,86), root:(1672,135),
    state 0x10, keycode 37 (keysym 0xffe3, Control_L), same_screen YES,
    XLookupString gives 0 bytes:
    XmbLookupString gives 0 bytes:
    XFilterEvent returns: False

KeyPress event, serial 31, synthetic NO, window 0x2200001,
    root 0x13b, subw 0x0, time 550714067, (91,86), root:(1672,135),
    state 0x14, keycode 65 (keysym 0x0, NoSymbol), same_screen YES,
    XLookupString gives 0 bytes:
    XmbLookupString gives 0 bytes:
    XFilterEvent returns: False

Right control + space :

KeyPress event, serial 31, synthetic NO, window 0x2200001,
    root 0x13b, subw 0x0, time 550783309, (88,289), root:(1669,338),
    state 0x10, keycode 109 (keysym 0xffe4, Control_R), same_screen YES,
    XLookupString gives 0 bytes:
    XmbLookupString gives 0 bytes:
    XFilterEvent returns: False

KeyPress event, serial 31, synthetic NO, window 0x2200001,
    root 0x13b, subw 0x0, time 550784541, (88,289), root:(1669,338),
    state 0x14, keycode 65 (keysym 0x0, NoSymbol), same_screen YES,
    XLookupString gives 0 bytes:
    XmbLookupString gives 0 bytes:
    XFilterEvent returns: False

Then I'm afraid you'll have to convince application developpers some layouts actually use the spacebar to output spaces and they can't assume ctrl+space is available for them to use.

I'll try to do that. As for now I close this bug.
Thanks for your help.

Sorry to reopen this one again, but no solution was found with upstream and some applications like rhythmbox and totem use Ctrl + space as accelerators which seems to be looked up by gtk_action_group_add_toggle_action. As Ctrl + space and space in this layout returns the same XLookupString (see above), we can't use space on those applications. This is particularly frustrating in the search field, for instance :)
(you can have a look at https://bugs.edge.launchpad.net/ubuntu/+source/rhythmbox/+bug/221112?comments=all already referenced in the thread)

I tried to read a whole bunch of documentation regarding what leads to the current chosen solution in oss (the "include level4nl") and talked to svu too.
So, the fix was from https://bugs.freedesktop.org/show_bug.cgi?id=9529#c29.

I still don't understand how the level5 applied to Right Ctrl and "clever" management of the modifier (LOCAL_EIGHT_LEVEL) impacts the left Ctrl key. Input there will be appreciated :)

So, the "bug" is workarounded if I include level4n for to replace level4nl. The XLookupString is no more the same. Apparently, there will be no more level 5 modifier (which is right ctrl, right?). Is it really useful? If I include "level5(rctrl_switch)", we will be back in what the fix was intented: no more rctrl working in some apps like virtualbox (I hope I'm right there).

So, here is the result of my research, do not hesitate to correct me if I'm wrong anywhere. What do you think about changing this (I can distro patch if needed) in Ubuntu switching include level4nl to include level4n and no more adding a 5th level?
(not sure what use the 5th level). Unbreakable space is still reachable by Altgr + v.

So, getting feedback on someone more technically involved would be great, thanks in advance!

To sum up

1. French language uses three forms of spaces (normal space, no-break space, short no-break space), as defined in official typographic rules
2. The natural key people expect to output those spaces is the spacebar
3. They can not be put on the first levels because experience shows too many users do not depress shift before the spacebar and generate nobreakspaces accidentally if shift/caps is used as modifier
4. The iso-defined key to access other levels is ctrlgr (right ctrl, see canadian multinational keyboard)

So there is *no* good alternative to use ctrlgr + spacebar to emit those symbols

IIRC xkb has problems distinguishing right ctrl and left ctrl. So you can try to open a bug on this problem so left ctrl + space does not trigger the fifth level.

But right-crtl+space won't be given to apps. If apps expect to grab it, apps are wrong.

This bug has been bothering me again.

Instead of
    include "nbsp(level4nl)"
I used:
    include "nbsp(level4n)"
    include "level5(rctrl_switch)"

With these parameters, Rhythmbox search is working correctly and we do have the thin nbsp on the sixth level (RCtrl+Shift+Space) as needed by Nicolas Mailhot.

Is this okay for you?

Lads, for me that makes no difference. Just please settle that between you

Could you make a choice at last? This bug is very annoying, and since the solution is here, please decide fast about it. Thanks! ;-)

I am ok with solution by zebob. Any objections? Nicolas?

Ping! ;-)

Sergey, can you commit any solution? Better get a fix than wait for ages to be sure it's the best choice.

Ok, committed that one. Please check.

Do note that the bug was reported AFTER switching back to the last fully functional version of xkb-data.

The right CTRL key is wrongly assigned to Level5 (see the attached picture).

It seems to be linked to this modification in wkeyboard-config
http://bazaar.launchpad.net/~alexeyten/xkeyboard-config/master/revision/1477#symbols/fr

It don't know what it tries to solve, but actually it creates more pain.

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in xkeyboard-config (Ubuntu):
status: New → Confirmed
Dominique Meeùs (dominiquem) wrote :

With Belgian OSS, I have the same Ctrl-R changed into Level5 as Emmanuel Castro (his attached image 2012-06-16).

It is probably because the config file for Belgian OSS include French OSS.
http://bazaar.launchpad.net/~alexeyten/xkeyboard-config/master/view/1477/symbols/be line 69

Par ailleurs, pour revenir à un clavier qui marche :
– lancez Synaptics (installez le si besoin),
– sélectionnez le paquet xkb-data.
– allez dans le menu "Paquets | Forcer la version...", sélectionnez 2.5-1ubuntu1 (precise) à la place de 2.5-1ubuntu1.2, et appuyez sur le bouton "Forcer la version" ;
– et enfin fermez votre session et ouvrez-en une nouvelle.

Longue vie au Ctrl-droit !

The solution posted in comment #27 disables the standard behaviour of the Right-Ctrl key. It is annoying for most users! (I first thought that my keyboard was broken).

See the bug 1013881 in Ubuntu
https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881

My opinion is that the right solution to solve the RhythmBox bug is to remove the line
  include "nbsp(level4nl)"
not patching the keyboard with the ugly
  include "level5(rctrl_switch)"

Maybe we can solve the nbsp handling as it is the problem.

Which language has a successful keyboard that handles nbsp?

Dominique Meeùs (dominiquem) wrote :

Thanks to Emmanuel Castro for the workaround (forcing a previous version).
The choice w

Dominique Meeùs (dominiquem) wrote :

Sorry, pushed some wrong key.

[The choice…] was between 2.5-1ubuntu1 (precise) and 2.5-1ubuntu2 (precise-proposed). On https://help.ubuntu.com/community/UbuntuUpdates, I read: « Enabling the proposed updates repository can break your system. It is not recommended for inexperienced users. » I didn’t know this. I unchecked Proposed in my updates choices for the future.

The update was introducing "level5(rctrl_switch)" in response to a long complicated discussion (https://bugs.freedesktop.org/show_bug.cgi?id=15804) about some applications using some Ctrl+space shortcut. To me it seems that everybody expects to have two Ctrl keys on a regular PC keyboard. Suppressing the right Ctrl should be an option for those who need it, not the default.

(In reply to comment #33)
> The solution posted in comment #27 disables the standard behaviour of the
> Right-Ctrl key. It is annoying for most users! (I first thought that my
> keyboard was broken).
>
> See the bug 1013881 in Ubuntu
> https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881
>
> My opinion is that the right solution to solve the RhythmBox bug is to remove
> the line
> include "nbsp(level4nl)"
> not patching the keyboard with the ugly
> include "level5(rctrl_switch)"
>
> Maybe we can solve the nbsp handling as it is the problem.
>
> Which language has a successful keyboard that handles nbsp?

right ctrl is the standard access key for level 5+6 (just like right alt is for levels 3-4 and yes you'll find keyboards where right alt is the same as left alt and not alt gr)

See for example this:
https://upload.wikimedia.org/wikipedia/commons/d/d0/KB_Canadian_Multilingual_Standard_comment-en.svg

So you can not remove right ctrl use without lowering the layout level number, and if you do so people start emitting nbsp my mistake (that was the biggest source of complain for one of this layout ancestors)

Thank you for the information.

I am puzzled by the way how the bug FreeDesktop bug 15804 was handled!
The correct way to solve the RhythmBox bug was to remove the line
include "nbsp(level4nl)"
not patching the keyboard with the ugly
include "level5(rctrl_switch)"

Ok, we are loosing the non-breaking space. Only people doing typesetting use it anyway. If the nbsp(level4nl) can't be solved for RhythmBox, maybe they should have their separate keyboard.

And what if instead of
    include "nbsp(level4nl)"
we put non-breaking space to level 3. I find it more convenient (
    include "nbsp(level4n)"
    include "level5(rctrl_switch)"

And what if instead of level 4, we put non-breaking space to level 3. I find it is more convenient (and I think I am not alone).

So, instead of:
    include "nbsp(level4nl)"
we put non-breaking space to level 3:
    include "nbsp(level3n)"

This gives us back the Right-Ctrl. It does not break RhythmBox behaviour any more. And people using non-breaking spaces will be happy.

And what if instead of level 4, we put non-breaking space to level 3. I find it is more convenient (and I think I am not alone).

So, instead of:
    include "nbsp(level4nl)"
we put non-breaking space to level 3:
    include "nbsp(level3n)"

This gives us back the Right-Ctrl. It does not break RhythmBox behaviour any more. And people using non-breaking spaces will be happy.

Thanks to Domique Meeùs for his useful suggetions

(In reply to comment #36)
> And what if instead of level 4, we put non-breaking space to level 3. I find it
> is more convenient (and I think I am not alone).
> So, instead of:
> include "nbsp(level4nl)"
> we put non-breaking space to level 3:
> include "nbsp(level3n)"
> This gives us back the Right-Ctrl. It does not break RhythmBox behaviour any
> more. And people using non-breaking spaces will be happy.

That's basically what fr-latin9 (the ancestor of fr-oss) used to do and it was changed to the current setting because too many people complained it made it too easy to type nbsp by mistake

(but now the nbsp behaviour is configurable so you should be able to override the default on your system if you wish)

Dave Gilbert (ubuntu-treblig) wrote :

High -> A problem with an essential hardware component (Keyboard)

Changed in xkeyboard-config (Ubuntu):
importance: Undecided → High

Do you need help from me to solve the problem?

Cordially

Emmanuel Castro

2012/6/24 Dave Gilbert <email address hidden>

> High -> A problem with an essential hardware component (Keyboard)
>
>
> ** Changed in: xkeyboard-config (Ubuntu)
> Importance: Undecided => High
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
>
> https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881/+subscriptions
>

Changed in xkeyboard-config (Ubuntu):
assignee: nobody → Canonical Desktop Team (canonical-desktop-team)
Sebastien Bacher (seb128) wrote :

Hey Bryce, could you look at that bug?

I can't confirm the issue there using a fr oss layout on my french precise but maybe it depends of special configs or interactions

Changed in xkeyboard-config (Ubuntu):
assignee: Canonical Desktop Team (canonical-desktop-team) → Bryce Harrington (bryce)

As stated previously (#9), the problem only appears when activating the
'precise-proposed' package source. However, if it is not solved now, the
problem will appear for every user using the French Oss keyboard (that is
most of French users).

2012/6/25 Sebastien Bacher <email address hidden>

> Hey Bryce, could you look at that bug?
>
> I can't confirm the issue there using a fr oss layout on my french
> precise but maybe it depends of special configs or interactions
>
> ** Changed in: xkeyboard-config (Ubuntu)
> Assignee: Canonical Desktop Team (canonical-desktop-team) => Bryce
> Harrington (bryce)
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
>
> https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881/+subscriptions
>

Sebastien Bacher (seb128) wrote :

Emmanual: reading the upstream bug we have the choice between

- having space input broken in media players (i.e rhythmbox)
- having rctrl broken
- having a layout that leads to wrongly input nbsp chars

neiher of those look to good and I'm not sure what's the best solution, I will need to check what lucid was doing but

- the rhythmbox issue was solved at this time (not sure if the fix was already breaking rctrl there)
- we really want the rhythmbox issue fixed, so if we have to choice we will pick one of the 2 other bugs
- I'm not sure how many users use rctrl, I'm french and I never used it nor saw people around me use ... are you left handed (I'm wondering if that reverses usage and if a lefty would use the right ctrl)?

until we get those questions sorted we will stay on the current behaviour which seems the less annoying from the ones listed

Yes, I am left handed! So what?

Having RCtrl broken is against the tradition of computer keyboards. It is
against the philosophy of Ubuntu: computer for people – including left
handed, those who are born with two hands, and those who have to type only
with one.

Letting a bug in Rhythmbox is not a good option too.

What does lead to wrongly input nbsp chars if we put it into level 3
instead of level 4?
Most of keyboards use level3, except a Finland one which use «include
"nbsp(level4)"», not «include "nbsp(level4n)"»

I think the the support of nbsp(level4n) is broken in X11.

And really, removing RCtrl is not an option.

2012/6/26 Sebastien Bacher <email address hidden>

> Emmanual: reading the upstream bug we have the choice between
>
> - having space input broken in media players (i.e rhythmbox)
> - having rctrl broken
> - having a layout that leads to wrongly input nbsp chars
>
> neiher of those look to good and I'm not sure what's the best solution,
> I will need to check what lucid was doing but
>
> - the rhythmbox issue was solved at this time (not sure if the fix was
> already breaking rctrl there)
> - we really want the rhythmbox issue fixed, so if we have to choice we
> will pick one of the 2 other bugs
> - I'm not sure how many users use rctrl, I'm french and I never used it
> nor saw people around me use ... are you left handed (I'm wondering if that
> reverses usage and if a lefty would use the right ctrl)?
>
> until we get those questions sorted we will stay on the current
> behaviour which seems the less annoying from the ones listed
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
>
> https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881/+subscriptions
>

Bryce Harrington (bryce) wrote :

The change is from patch 109_fr_oss_space_char.patch which was brought in with version 2.5-1ubuntu1.1. Changing the behavior of the right control key was intentional, as requested by reporters in bug #221112 to fix a bad problem that occurs when using Rhythmbox.

2.5-1ubuntu1.1 is included in precise-updates now, since the SRU request was accepted and processed. So it's too late to pull the fix, it'd need a new SRU filed with a reversion.

Note that the patch in question was also included in Lucid and Maverick as a Ubuntu-specific patch (when RB was the default music player), but inadvertently got dropped for natty and oneiric. Meanwhile, the patch was sent upstream and accepted there. While the patch is a behavioral change compared with oneiric, since it preserves a behavior fixed in Lucid it seems sensible to me to include it to eliminate the LTS->LTS behavior change.

As to the proposed alternate solution, I am open to that if it does indeed fix things for both parties, *and* if it gets taken upstream. I see that bug reporters have already raised that upstream, so thanks! What we're going to do is wait and see what upstream thinks about it, and if/when they commit a fix we can consider pulling it for Ubuntu too.

Changed in xkeyboard-config (Ubuntu):
status: Confirmed → In Progress

Since "2.5-1ubuntu1.1 is included in precise-updates now", I guess this bug will become very popular...
Excuse my ignorance, but what is the SRU.
When you say "upstream", do you mean the FreeDesktop bug?

Sebastien Bacher (seb128) wrote :

> Yes, I am left handed! So what?

Nothing specific, you took that the wrong way, as said I was trying to have a feeling of what percentage of the users it concerns and what is their usecase, I didn't say it was fine to bug anyone, but understand that any of the suggested solution so far do bother a part of the userbase, so we are stucked in choising what part is the smallest one or what issue is easier to work around

> Since "2.5-1ubuntu1.1 is included in precise-updates now", I guess this bug will become very popular...

No, it's not, as pointed before that patch and behaviour was default in Ubuntu in the lucid LTS and for years and we get very few negative feedback about it, I'm sorry it's impacting you directly but that doesn't make it an issue that impact every french user...

> Excuse my ignorance, but what is the SRU.

"stable release update", that's how we can bug fixes uploaded to stable series

> When you say "upstream", do you mean the FreeDesktop bug?

yes

Sebastien Bacher (seb128) wrote :

note also that the bug is easy to work around, you can change for another french layout than the "french (variante)" one in the system settings

Sebastien Bacher (seb128) wrote :

Ok, checking on lucid, by then we had this fix:
http://launchpadlibrarian.net/44180279/xkeyboard-config_1.8-1ubuntu6_1.8-1ubuntu7.diff.gz

"# Description: Don't include level4nl but only level4n for french oss layout.
# both space and Ctrl + space returned the same XLookupString, which prevents
# space using in some application using gtk_action_group_add_toggle_actions
# to setup Ctrl + space accelerator. We loose rctrl accelator but that's better
# than not having space in those applications and setup it manually will
# reintroduce https://bugs.launchpad.net/bugs/198759
# Ubuntu: https://launchpad.net/bugs/221112
# Upstream: http://bugs.freedesktop.org/show_bug.cgi?id=15804

Index: xkeyboard-config-1.8/symbols/fr
===================================================================
--- xkeyboard-config-1.8.orig/symbols/fr 2010-04-14 17:52:47.850615502 +0200
+++ xkeyboard-config-1.8/symbols/fr 2010-04-14 17:53:03.174604295 +0200
@@ -129,7 +129,7 @@

     include "latin"
     include "level3(ralt_switch)"
- include "nbsp(level4nl)"
+ include "nbsp(level4n)"
     include "keypad(oss)"

     name[Group1]="France - Alternative";"

so by then we didn't add the "include "level5(rctrl_switch)"" line ... does anyone know why it was added this time? it seems lucid in fact had both rhythmbox and rctrl working

Steve Langasek (vorlon) wrote :

Bryce,

> 2.5-1ubuntu1.1 is included in precise-updates now, since the SRU
> request was accepted and processed.

No, it isn't. The 2.5-1ubuntu1.2 SRU was accepted (incorrectly) into precise-proposed before 2.5-1ubuntu1.1 was promoted to precise-updates.

I've just tested the patch from Sebastian, i.e. removing the «include "level5(rctrl_switch)"» from the current "precise-proposed" package. The behavior is Ok for me:
– Right Ctrl works
– Rhythmbox Ctrl-Space works
– Nbsp is available (on level 4).

Now, what is the procedure to cook the patch of the patch?

Bryce Harrington (bryce) wrote :

Steve, ah, weird, I assumed the previous version was supposed to get pushed to -updates before a new sru would go in.

In that case, then yes I can just discard the earlier fix. I've done so and re-uploaded 2.5-1ubuntu1.3 with that reverted out.

Sebastien Bacher (seb128) wrote :

@Emmanual: we will get an update with the other pending fixes out while the question of the space,ctrl issue is sorted, we will address that one in another update

Hello Emmanuel, or anyone else affected,

Accepted xkeyboard-config into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/xkeyboard-config/2.5-1ubuntu1.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-needed

Unfortunately, the test failed:
– Right Ctrl works => OK
– Rhythmbox Ctrl-Space works => KO
– Nbsp is available (on level 4) => OK

I think it w

Unfortunately, the test failed:
– Right Ctrl works => OK
– Rhythmbox Ctrl-Space works => KO
– Nbsp is available (on level 4) => OK

I think I was not clear in comment #24. The comment #22 of Sebastien Bacher is clearer.
The line 128 of symbol/fr
    include "nbsp(level4nl)"
must be replaced by
    include "nbsp(level4n)"

For an unknown reason, the line «include "nbsp(level4nl)"» produces the bug of Rhythmbox.

Next time might be the right time.

tags: added: verification-failed
removed: verification-needed
Steve Langasek (vorlon) wrote :

Emmanuel, the intent of this latest upload is to roll back *all* changes to the space handling, so that the SRU can proceed with the other unrelated fixes rather than being blocked by a perfect solution to this one.

From that perspective, my understanding is that the change that's applied here *has* fixed the issue you reported in this bug, hasn't it? In that things now work consistently for you between versions 2.5-1ubuntu1 and 2.5-1ubuntu1.3 of xkb-data?

In that case, could you please mark this bug 'verification-done' rather than 'verification-failed', and we'll use the original bug, bug #221112, for tracking the Ctrl+Space issue.

Ok

tags: added: verification-done
removed: verification-failed
Sebastien Bacher (seb128) wrote :

@Emmanual: the reason we rolled back rather than include that nl->n 1 liner change is that we want to see the other fixes out and it's still not clear that the change is the correct one and wouldn't create issues and lead to another SRU verification fail.

Do you know the drawbacks we would have exactly with doing that change? It was mentioned upstream that it would make easier to insert nbsp chars by mistake, would you consider that a regression?

I've analysed the use of nbsp(levelX) in all the keyboards defined in
/usr/share/X11/xkb

Keyboards defining nbsp on level 3:
./symbols/tr: include "nbsp(level3)"
./symbols/fi: include "nbsp(level3)"
./symbols/lt: include "nbsp(level3)"
./symbols/fr: include "nbsp(level3)" // "French (legacy,
alternative)"
./symbols/no: include "nbsp(level3n)"
./symbols/ca: include "nbsp(level3s)"

Keyboards defineinf nbsp on level4:
./symbols/fi: include "nbsp(level4)"
./symbols/fi: include "nbsp(level4)"
./symbols/fr: include "nbsp(level4nl)" // The only keyboard using
level4nl -- which I think is buggy.

What nbsp(levelX) exactly means:
  nbsp:level2 Non-breakable space character at second level
  nbsp:level3 Non-breakable space character at third level
  nbsp:level3s Non-breakable space character at third level,
nothing at fourth level
  nbsp:level3n Non-breakable space character at third level, thin
non-breakable space character at fourth level
  nbsp:level4 Non-breakable space character at fourth level
  nbsp:level4n Non-breakable space character at fourth level, thin
non-breakable space character at sixth level
  nbsp:level4nl Non-breakable space character at fourth level, thin
non-breakable space character at sixth level (via Ctrl+Shift) ---- Broken
with RhythmBox

We have the following choices after dropping the level4nl (which is the
cause of the RhythmBox problem):
– using level4n works (I've tested it), but actually I can't produce
thin-nbsp as I don't know how to get sixth level. However, fr-oss defines
thin-nbsp on AltGr-V.
– using level4 might work just like level4n (I can test it). It has the
advantage of being in use in finish keyboard (fewer risk of bug).
– level3s is in use in Canada, but as you said, some people have complained
that it leads to mistyping (I don't agree, but it is only my opinion).

If you want nbsp accessible from the space bar, with a slight change for
those who use AltGr-Shift-Space to get nbsp, choose level3n.
     * nsbp on AltGr-Space / thin-nbsp on AltGet-Shift-Space and AltGr-V)
If you want a conservative choice, choose level4 (thin-nbsp still available
on Alt-Gr V).
     * nsbp on AltGr-Shift-Space / thin-nbsp on AltGr-V)

I prefer the first option, but I won't complain if you choose the
conservative one.

Clint Byrum (clint-fewbar) wrote :

The fix for this cannot progress to precise-updates until it is fixed in quantal. Can somebody please confirm that the bug is fixed in quantal? Preferrably by marking the bug status as 'Fix Released'.

Changed in xkeyboard-config (Ubuntu Precise):
status: New → Fix Committed
importance: Undecided → High
Steve Langasek (vorlon) wrote :

This particular bug pertains to the /reverting/ of a patch that was included in a previous SRU upload that was not yet promoted to -updates. So solving this in quantal should not be a blocker for promoting this SRU.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package xkeyboard-config - 2.5-1ubuntu1.3

---------------
xkeyboard-config (2.5-1ubuntu1.3) precise-proposed; urgency=low

  * Add 113_ossmath_is_five_levels.patch: Some keymaps like fr(oss) fail to
    load because they include ossmath (via keypad(oss)) which
    misconfigures the keypad as 4-level when it should be 5-level. This
    patch from upstream bugzilla fixes this by adding the 5th level to the
    ossmath definition.
    (LP: #985065)
  * Drop 109_fr_oss_space_char.patch change; the fix causes behavioral
    changes for right control which a fr(oss) user did not like.
    (LP: #1013881)

xkeyboard-config (2.5-1ubuntu1.2) precise-proposed; urgency=low

  * Add 111_cz_ssharp.patch: Fix mapping of 4th level of the AC11 key to
    ssharp rather than quotedbl for the Czech layout. Cherrypick of
    patch from upstream.
    (LP: #953477)
  * Add 112_dk_dvorak_tilde.patch: Fix tilde key in the Danish Dvorak
    layout. It's not the same as Norwegian as has been assumed previously.
    (LP: #989626)

xkeyboard-config (2.5-1ubuntu1.1) precise-proposed; urgency=low

  * Add 109_fr_oss_space_char.patch: Fix problems using space bar in various
    applications when using the fr(oss) keymap.
    (was for LP bug 221112)
  * Add 110_dead_hook_horn.patch: Add two deadkeys on level 3 and 4 of the
    j key for the latin keymap.
    (LP: #825624)
 -- Bryce Harrington <email address hidden> Mon, 25 Jun 2012 17:32:15 -0700

Changed in xkeyboard-config (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package xkeyboard-config - 2.5-1ubuntu6

---------------
xkeyboard-config (2.5-1ubuntu6) quantal; urgency=low

  * Disable patch 109. The fix causes behavioral changes for right
    control. Needs to be fixed differently; discussion ongoing upstream.
    (LP: #1013881)
 -- Bryce Harrington <email address hidden> Thu, 19 Jul 2012 14:08:18 -0700

Changed in xkeyboard-config (Ubuntu):
status: In Progress → Fix Released
Changed in xkeyboard-config:
importance: Unknown → Medium
status: Unknown → Confirmed

So, lads, with configurable nbsp - is there any solution that would make you all reasonably happy?

(In reply to comment #39)
> So, lads, with configurable nbsp - is there any solution that would make you
> all reasonably happy?

Is there a way to make the spacebar more neutral *except* for the combinations that trigger something else than space? The main complain seems to be that some apps want to grab space combinations (which is a really stupid idea IMHO) so can xkb work ass passthrough except for the specific combos used for nbspc?

I am honestly not sure how to translate that requirement into XKB terms...

I agree - intercepting those combinations is really odd. So I always have possibility to close this as WONTFIX. But if we manage to invent something - that would be better..

> can xkb work ass passthrough
It took me a while to parse that typo - was meditating over it for a minute;)

This reminds me of bug #45008. Just here, LOCAL_EIGHT_LEVEL does not preserve Control. Adding preserve[Control]= Control into LOCAL_EIGHT_LEVEL might fix the issue, an as it is not used elsewhere, it actually might be acceptable [but it also means that LOCAL_EIGHT_LEVEL in really a waste, given that other types had to be removed because some programs had problems with too many types]. I do not have rythmbox, so I cannot test.

> with too many types]. I do not have rythmbox, so I cannot test.
Can anybody with rhythmbox try that?

Hello,

Until a solution is to be found, could 518c769d be reverted for now? Breaking the very standard behavior of right control in all applications (e.g. xterminals!!) is really not acceptable, compared to the few issues that the behavior has without it.

Samuel

(In reply to comment #44)
> Hello,
>
> Until a solution is to be found, could 518c769d be reverted for now?
> Breaking the very standard behavior of right control

It does not break the very standard behavior of right control any more than altrgr breaks the very standard behavior of right alt

It's exactly the same mechanism as endorsed in other official French layouts like the Canadian one

Download full text (4.9 KiB)

(In reply to comment #45)
> (In reply to comment #44)
> > Until a solution is to be found, could 518c769d be reverted for now?
> > Breaking the very standard behavior of right control
>
> It does not break the very standard behavior of right control any more than
> altrgr breaks the very standard behavior of right alt

For me it does. My keyboard has an "Alt Gr" label on the AltR key, so it indeed is expected to behave differently from Alt_L, but my ControlR key is labeled as "Ctrl", just like the ControlL key. And all other keyboards and OSes I ever used did handle ControlR the same as ControlL, as far as I was concerned as a user.

Also, I find it more generically problematic to change the behavior of a common key on a widely used keymap. For example the change annoyed me for about a month before I took the time to debug this and edit my keymap -- and I can't imagine what a lambda user could do but learn to deal with it.

Also, what is Level5 used for? IIUC, currently nothing but short-nbsp (or at least that I can find, which is practically the same from a user POV), turning Ctrl_R into a virtually useless key.

So, what can we do?

First, please note, for what is worth, that both Rhythmbox and Totem, which were cited as the applications having a problem with the previous state of things, are not affected anymore. Rhythmbox don't use Control+Space as a shortcut anymore, and Totem seem to react to any space keysym, no matter the modifiers.
So, unless there actually are other applications using Control+Space and suffering of the issue (Code::Blocks?), the problem does not even exist anymore.
Also, maybe I just don't know how one is supposed to process the events, but those bugs look like an application or toolkit issue to me, is it?

Then, practical changes. Before the change, Space behaved like this:

 Shift* | Control* | Level3 || keysym | XLookupString
 ---------------------------||--------------------------
        | | || 0x20 | 20
 X | | || 0x20 | 20
        | X | || 0x20 | 20
        | | X || 0x20 | 20
 X | X | || 0x100202f | e2 80 af
 X | | X || 0xa0 | c2 a0
        | X | X || NoSymbol |
 X | X | X || NoSymbol |

And now we have:

 Shift* | ControlL | Level3 | Level5 || keysym | XLookupString
 ------------------------------------||---------------------------------
        | | | || 0x20 | 20
 X | | | || 0x20 | 20
        | X | | || 0x20 | 00
        | | X | || 0x20 | 20
        | | | X || 0x20 | 20
 X | X | | || 0x20 | 00
 X | | X | || 0xa0 | c2 a0
 X | | | X || 0x100202f | e2 80 af
        | X | X | || 0x20 | 00
        | X | | X || 0x20 | 00
        | | X | X || NoSymbol |
 X | X | X | || 0xa0 | (empty)
 X | X | | X || ...

Read more...

For some reason, I found myself using the 'fr oss' layout in Gnome 3.10. And I must say that finding out that this layout was picked as the default left me speechless: two keys on my keyboard no longer behave according to what's *on* the actual key:

 - the right control key, which just says "Ctrl", just like its left counterpart,
 - and the keypad's del/dot key which has an actual dot on it, not a comma

Both of those changes are incomprehensible. Whether *alternative* layouts exist to provide new mappings is of no issue to me. But a layout touted as the default layout should respect what's *engraved* on keyboards.

FTR, the original 'fr' layout also has that keypad dot/comma issue but not the right control mapped to Level5, but at least there's an "kpdl:dot" option to fix the former. So I fumbled through Gnome's ever-changing control panel and managed to change back to it.

(In reply to comment #46)
> For me it does. My keyboard has an "Alt Gr" label on the AltR key, so it
> indeed is expected to behave differently from Alt_L, but my ControlR key is
> labeled as "Ctrl", just like the ControlL key. And all other keyboards and
> OSes I ever used did handle ControlR the same as ControlL, as far as I was
> concerned as a user.

+1, all the French PC keyboards I have owned for the past 15 years have been like this. I can only add my voice to let it be known that having to fix my keyboard layout for correct operation was quite upsetting.

Anyhow, thanks to all for looking into it.

I spent a couple days extremely disappointed to have a broken right [CTRL] key on a french keyboard on recent Arch installs, thus being unable to use VirtualBox properly, and googling around (and let me tell you that my googling showed me a *lot* of french people are really upset with this as well) I finally found out that this breakage comes from this commit :

http://cgit.freedesktop.org/xkeyboard-config/commit/symbols/fr?id=518c769df2e9ce70cb721769a08b81504f243b2a

( http://goo.gl/SWU8Is )

Let me tell you that this breakage of right [CTRL], assigning it to ANOTHER function than right [CTRL] is completely inappropriate and upsetting.

I therefore hereby specifically request this absurd modification to be reverted.

More arguments in favor of reverting to an normal behaviour of Ctrl-R:
-- Most computers in most operating systems, languages (including French until recently), desktops... have two identical Ctrl keys. It is queer to have French keyboards doing otherwise since a few years.
-- Like having two Shift keys, two Ctrl keys are better for easy fast typing.

By the way, breaking the French keyboard breaks the Belgian keyboard too.

Dominique Meeùs (dominiquem) wrote :

This bug is still present in package xkb-data 2.10.1ubuntu1 (trusty):
include "level5(rctrl_switch)"

Could someone create poll on some french(belgian) web site, linux-oriented. Which behavior would be preferable?

(In reply to comment #50)
> Could someone create poll on some french(belgian) web site, linux-oriented.
> Which behavior would be preferable?

Is this even necessary? I mean, the change wasn't made in the first place because an user wasn't happy with the state, but because some apps couldn't handle it. And nowadays, at least some of those apps (Rhythmbox, Totem, …) have been fixed or altered in a way they do not suffer from it anymore, actually mostly nullifying the original point.

Also, what a poll would do? This looks like a pretty subtle problem to me, and an uneducated user couldn't really tell. As far as they are concerned, I would think they just want everything working.
Even me, if you ask I would say (as in my previous reply) just fix the XLookupString while keeping the original mapping, since IIUC it would fix everybody's issue. But I have no real clue whether it's a pertinent answer or not.

That was just an idea. As usual, when there are controversies... Trying to be democratic:)

(In reply to comment #50)
> Could someone create poll on some french(belgian) web site, linux-oriented.
> Which behavior would be preferable?

A poll would be pointless as its representativeness would be very hard to determine.
Most users don't care "as long as it works" and may not even know there is a poll somewhere.

The matter is : French keyboard have, and have always had since the PC keyboards exist (that makes 30 years), 2 similar [CTRL] keys that have the same printed label and are expected to exhibit the same behaviour.

AND THEY ALWAYS HAVE BEEN SO IN ANY LINUX OR "other OS" keymaps, and especially default keymaps - if anybody wants to customize HER keyboard, then it's HER choice, but by no means a default.

OTOH French keyboard have a left [Alt] key and a right [AltGr] keys having different labels and expected to have different roles.

This is extremely clear. Both [CTRL] keys should act as [CTRL] keys. Left one, rigth one, period.

Some softwares - such as Virtualbox - will want to use the left or right CTRL key for some specific role, and then it's printed in their documentation and the corresponding key is supposed to exist and be correctly mapped. It is nonsense to find oneself with a keymap in which some highly classical and standard key just doesn't happen to exist anymore just because of a once-upon-a-time existing issue (since solved) with a shortcut on a music player that nobody cares about !?!?!? You don't want to break a professional keyboard just because of arguable choices in a toy !

Swâmi Petaramesh, vous avez bien raison !

Hopefuly, Ubuntu 13.10 kept the standard behavior for french keyboards
(both Français and Français (variante) a.k.a French alternative).

So, finally, is everybody happy with me removing that line:

include "level5(rctrl_switch)"

? If no objections within next week - I will just drop it.

I had yet another good reason to revert to a "normal right [CTRL] key" on a Fedora this morning:

I was working in a terminal with several open terminal tabs. Switching between tabs is made using [Ctrl]-[PageUp] and [Ctrl]-[PageDown] - same goes with other Gnome tabbed apps, as well as Firefox and Chromium...

If you have a working right [Ctrl] key, switching tabs is easy, you just need 2 fingers from your right hand.

If you don't have a working right [Ctrl] key, you need both hands.

Having the broken right [Ctrl] key was so annoying at work, that I had to fix it immediately.

(In reply to comment #54)
> So, finally, is everybody happy with me removing that line:
>
> include "level5(rctrl_switch)"

No, just didn't see the point of restating what has already been written before

A level 5 map needs a level 5 switch, iso defined right ctrl as default level 5 switch so there is no better option available, and users who do not care about the fifth level can choose another spacebar variant since they are configurable.

Repeating :

1/ Standard French keyboard has NO [CtrlGr] key. It does have 2 normal [Ctrl] keys bearing the exact same label. The right [Ctrl] key actually is a right [Ctrl] key and no other modifier or whatever.

2/ There are quite a *lot* of common, daily used by professional IT staff, keyboard shortcuts or combinations such as [Ctrl]-[Arrows], [Ctrl]-[PageUp/Down], [Ctrl]-[Home], [Ctrl]-[End], plus all such combinations adding [Shift], then [Ctrl]-L, [Ctrl]-M...

-> All these day-long used combinations can be conveniently played with 2 (or 3) fingers when the right [Ctrl] key actually is a right [Ctrl] key, and changing this key breaks them all, needing people to start using both hands for typing what they have typed with 2 fingers for 30 YEARS ! And mistype. And mistype. And mistype.

3/ The issue with Rythmbox looks solved for long, and who wants to break professional use of a keyboard for a solved bug in a music player ?

4/ Nobody (normal user) I talked to has ever heard about a "level 5" story, nor do people give a damn.

5/ Everybody wanting to type non-breakable space in word processors (LibreOffice...) do it with [Ctrl]-[Shift]-[Space] and don't need a specifically modified right Ctrl for that.

6/ Breaking right [Ctrl] breaks other apps that specifically request it NOT to be broke, such as [VirtualBox] - again professional stuff.

Breaking the right [Ctrl] keys on the french keyboard is plain stupid, period.

I never heard of or used the level5 either, but to solve the issue could we maybe put it in another layout? For example something like "oss-level5"?

I personally have to patch the file on every package update and even if I'm used to that and have the patch ready now, it gets annoying. On my laptop the right Ctrl key is adjascent to the arrows and it's way more convenient to be able to move through words in a text using only the right hand.

Even though I've been an IT professional for the past 3O years, I went to a large computer store in France over lunch time, to find out if such thing as a [CtrlGr] key could possibly exist on a french keyboard.

Let me tell you : I couldn't find any.

OTOH, I was surprised to notice that some tablets with removable keyboards, as well as some ultrabooks with space-saver keyboards, did not have a right [Ctrl] key at all !

All have a left [Ctrl], left [Alt] and right [AltGr].

The vast majority of times, they have a right [Ctrl] key which is similar to the left one.

But sometimes there is no right [Ctrl] at all !

This single fact prohibits a standard keymap giving a different assignation to the right [Ctrl] key, because this key may well not even exist on a given keyboard ! Thus you cannot rely on it for any feature that could be positively necessary.

That makes Yet Another Good Reason™ to keep the good 'ole behaviour of having 2 similarily mapped [Ctrl] keys.

pdecat (pdecat) wrote :

Just upgraded to Trusty and found about this "not working Right-Ctrl"-gate. What a PITA.

My work-around for now : select "Français (variante obsolète)"

Regards,
Patrick.

Gentlemen, I am really stuck at that point. I am refusing to make any changes before there is either some kind of agreement - or there are some minimally conclusive voting results.
I do not take any sides (I cannot have any personal opinion, not using French). I am just freezing the situation.

Sergey, you might want to check Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/xkeyboard-config/+bug/1013881 , which is a "downstream reflection" of this one.

There are some other "loud voices" there that you might consider as taking part to the "vote" that you want.

I had in my office 2 peopl that complained about this, this month. Maybe you could count them as well ?

BTW Sergey, I'm a bit surprised that you want a "vote" to fix something that people complain about, when you didn't need any vote to break it in the first place...

Would you need a vote, I suggest that you put a survey system online by yourself on any web page that you'd like (so you know the vote is "impartial"), and we let people know about it...

If you asks for a vote, it sounds logical that you organize it.

I vote for "Both [CTRL] keys should act as [CTRL] keys.
Left one, rigth one, period."

If it is not clear enough : Je vote pour que "les deux touches [CTRL]
agissent comme une touche [CTRL], la gauche, la droite, point-barre !"

Et arrêtez vos conneries

2014-04-18 6:56 GMT+02:00 Swâmi Petaramesh <email address hidden>:

> BTW Sergey, I'm a bit surprised that you want a "vote" to fix something
> that people complain about, when you didn't need any vote to break it in
> the first place...
>
> Would you need a vote, I suggest that you put a survey system online by
> yourself on any web page that you'd like (so you know the vote is
> "impartial"), and we let people know about it...
>
> If you asks for a vote, it sounds logical that you organize it.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/xkeyboard-config/+bug/1013881/+subscriptions
>

I feel extremely uneasy because I am a user of free software and I am full of respect and gratitude for the people who make this possible, including of course Nicolas Mailhot. I am an amateur and I am conscious that I rely entirely on the work of devoted paid and unpaid professionals.

But in this case, I must crudely say, because it was hinted that we should have a vote: the vote already happened, here in Bugzilla, and in Launchpad, and elsewhere in many forums. The result obviously is: Nicolas Mailhot against the rest of the world.

I think the rest of the world constitutes a majority compared to Nicolas Mailhot alone. Therefore one should immediately revert to the last good version with two Control keys.

(In reply to comment #60)
> Gentlemen, I am really stuck at that point.

Allow me to sum it up.

 - Nicolas is the sole advocate of having Control_R mapped to Level5.
 - The rest of us want to go back to having both left and right Control behaving the same way.

I'm not quite sure how you want us to organize a vote or poll. French Linux users (just like non-French ones) use a variety of distributions (which, BTW, may not ship the changed version of xkeyboard-config), and may not even all use a French keyboard (I'd say roughly half of my Linux-using friends and coworkers are using US qwerty layouts or mac layouts).

Since apparently no hardware maker is following ISO standards, may I suggest creating new layouts such as "oss-iso" with Nicolas' changes?

As one of Gentoo's X11 maintainers, I am really tempted to just revert that change downstream. The few French users I have talked to were just as surprised as I was to lose their Control_R key for no apparent reason.

I could organize a poll on my blog but being aggregated only on Planet Gentoo, I wouldn't give much credit to any numbers I could find.

Great ! Now the FR right [Ctrl] is B.R.O.K.E.N on Ubuntu 14.04 as well.

Given the number of french Ubuntu users (+ upcoming derivatives) I think you'll have your "vote" and "survey" very soon, just by taking a look at lauchpad bug entries and new comments on https://bugs.launchpad.net/bugs/1013881 - which are not reflected here - some of the latest ones being very hmmm... "vocal".

Hello,

I am french, I use the "Français (variante)" keymap because I like how the keys are arranged (², ³, œ, etc).
I also am left-handed and use Ctrl-Up and Ctrl-Down to switch desktops. I do so by using RCtrl + arrows, keeping my left hand on the mouse.

Now, on Ubuntu 14.04, I am also suffering from this weird "level5" thing. For some reason I don't really understand, I should now use both hands to change desktops (I replaced Ctrl-Alt-Up/Down with Ctrl-Up/Down with to not use both hands, as you understood).

By the way, as stated in a previous comment, RCtrl is a very important key on VirtualBox...

I would also like to add that Ctrl-PgUp and Ctrl-PgDown, to change tabs in tabbed apps (GNOME Terminal or Firefox, for example), now need a manipulation involving both hands.

This is clearly a big regression, at least for left-handed people, probably for right-handed people too...

> Since apparently no hardware maker is following ISO standards, may I suggest
> creating new layouts such as "oss-iso" with Nicolas' changes?
Nicolas, what do you think?

Regarding the voting, is there generic popular Linux-oriented site in France? Like slashdot.org or smth...

> is there generic popular Linux-oriented site in France? Like slashdot.org or smth...

LinuxFr.org

alex (a-jaury) wrote :

Bonjour, moi aussi je préfère que ma touche rctrl (Control R) se comporte comme une touche Control, et non comme level5_machin_chose.

Merci d'avance,
alex

Hello, so would I rather my rctrl key to behave as a control key.

Thanks,
alex

By the way, with this modification, the drawing around line 120 in/usr/share/X11/xkb/symbols/fr is wrong because it shows a keyboard with a Ctrl key on the right, not a Level5 thing...

Give us back - please - the right control key acting the same as left control key.

http://forum.ubuntu-fr.org/viewtopic.php?id=1563071

Claire Brione (cbrione) wrote :

I really do not understand why this key is disabled. If it is there, it is certainly not to make the keyboard look pretty.

Okay, your "vote" is currently happening on

https://bugs.launchpad.net/bugs/1013881

with 4 new entries today (from different people), 100% of them saying :

« PLEASE GIVE US OUR RIGHT [CTRL] KEY BEHAVING AS A [CTRL] KEY BACK !!! »

To summarize further, AFAIK, there is ONE person in the world happy that the french right [CTRL] has been broke, 100% of the other french keyboard users who want their [CTRL] key back,...

...and the rest of the world doesn't use a french keyboard and doesn't care.

Yes, please give it back !
Moreover I got two "Super" keys (with windows logo), why my right Super is also broken ? Is it the same problem as Ctrl ?

Rendez-vous la touche Ctrl-Droite, souiplait :-/

PLEASE GIVE US OUR RIGHT [CTRL] KEY BEHAVING AS A [CTRL] KEY BACK !!!
It is especially important for left-handed people.

Nicolas, I understand the logic in your position about Level 5. But I see a number of unhappy people. Could we find some other level5 chooser?

G-rom (g-rom-sempai) wrote :

I discovered that bug with Ubuntu 14.04. Seriously what's the hell!

Sorry to be rude but Nicolas you seriously fucked up here and raised an hungry mob.

I'm a full time developper and I just cannot think about writing code without CTRL_R. It make me feel so hungry when I discovered that bug and even more at what caused that. I was like: WTF Seriouslyyyyyyyyyy FUUUUUUUUUUUUUUUU

Temp fix:

echo 'keycode 105 = Control_R' >> ~/.Xmodmap
echo 'add Control = Control_R' >> ~/.Xmodmap
echo 'xmodmap ~/.Xmodmap' >> ~/.bashrc
source ~/.bashrc

Before searching a level5 chooser, please, a quick fix!

2014-05-02 0:59 GMT+02:00 Sergey V. Udaltsov <email address hidden>:

> Nicolas, I understand the logic in your position about Level 5. But I
> see a number of unhappy people. Could we find some other level5 chooser?
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/xkeyboard-config/+bug/1013881/+subscriptions
>

(In reply to comment #66)

> Regarding the voting, is there generic popular Linux-oriented site in
> France? Like slashdot.org or smth...

There is a popular Linux-oriented site in France (linuxfr.org) and the final ajustments of this layout were done after discussion on this site.

I realise there is a vocal minority that does not like some of those choices but
1. the other alternatives used in the ancestors of this layout generated a lot more hate mail
2. because I knew there was no choice everyone would like spacebar layout is modular (and I'm the person who modularized it as part of the creation of this layout). People can choose the previous behaviour if they want and a few other possibilities were added as part of the modularization
3. so far no one proposed any better option appart from removing symbols which are necessary to write proper French (arguably proper French is not the same as C code). It's a lot easier to clamor for removal of the bits you do not use than to try to design a general-purpose solution without cutting corners

(In reply to comment #69)

> > Regarding the voting, is there generic popular Linux-oriented site in
> > France? Like slashdot.org or smth...
>
> There is a popular Linux-oriented site in France (linuxfr.org) and the
> final ajustments of this layout were done after discussion on this site.
>
> I realise there is a vocal minority that does not like some of those choices

A site like linuxfr.org may well be a vocal minority in itself. Nothing proves that linuxfr.org is representative of ordinary users. And even on linuxfr.org I have seen posts saying "where is my CRTL-R gone?" or "my keyboard is broken since some new version of Ubuntu".
In a way, suppressing one of the customary CTRL keys is intrinsically a minority point of view.
[Furthermore, the French layout for the Belgian keyboard depends on the French layout for the French keyboard. I do not see why a discussion on linuxfr.org should decide that Belgians have no use of right CTRL.]

> but
> 1. the other alternatives used in the ancestors of this layout generated a
> lot more hate mail

I doubt having a right CTRL key ever generated hate mail. That hate mail was about other questions.

> 2. because I knew there was no choice everyone would like spacebar layout is
> modular (and I'm the person who modularized it as part of the creation of
> this layout). People can choose the previous behaviour if they want and a
> few other possibilities were added as part of the modularization

We are not here discussing space bar, but right CTRL. Is right CTRL modular? Is there an option easily accessible to the ordinary user to restore right CTRL?

> 3. so far no one proposed any better option appart from removing symbols
> which are necessary to write proper French (arguably proper French is not
> the same as C code). It's a lot easier to clamor for removal of the bits you
> do not use than to try to design a general-purpose solution without cutting
> corners

The clamor is not against proper French of for removal of anything. Furthermore, how could an ordinary user "try to design a solution"? The user wants a common PC keyboard with CTRL keys, without having to write the code himself. The clamor is: do what you can to allow writing proper French —and thank you for your trying to do it— but leave the right CTRL.
-------
If no agreement can be reached, would it be possible to have the old layout accessible, even under another name? I do not know how many variants are allowed, by design, or by freedesktop conventions. Of course a new variant would be useless if it didn’t appear in the choices offered to an ordinary user by the most popular GNU Linux distributions.

Download full text (3.5 KiB)

(In reply to comment #69)
> (In reply to comment #66)
>
> > Regarding the voting, is there generic popular Linux-oriented site in
> > France? Like slashdot.org or smth...
>
> There is a popular Linux-oriented site in France (linuxfr.org) and the
> final ajustments of this layout were done after discussion on this site.

But this has the same pitfall as any volunteered survey, it isn't any kind of representative. I for example myself barely ever read a linuxfr article, and wouldn't participate or even see a survey there. That doesn't mean I'm not a French fr/oss user :)

Also note that people suffering from the situations are a lot more likely to do something and speak their mind than people perfectly happy with the situation. So probably "discussing" a problem is likely to only include opinion from people not happy with the current state, and people closely involved.

> I realise there is a vocal minority that does not like some of those choices
> but

Just to be fair, I see *no one* else here arguing towards keeping right Ctrl Level5 modifier -- but sure, as I state above, people happy with it won't see the discussion or care, so it may be biased.

> 1. the other alternatives used in the ancestors of this layout generated a
> lot more hate mail

If it broke people's apps (or apps broke with it, I don't care who's fault it is), I surely can understand people being angry. But similarly, since the change from this report broke people's right Ctrl key, I can understand they get angry.

> 2. because I knew there was no choice everyone would like spacebar layout is
> modular (and I'm the person who modularized it as part of the creation of
> this layout). People can choose the previous behaviour if they want and a
> few other possibilities were added as part of the modularization

And we thank you for your work. But I don't think it's realistic to think everyone can "choose the previous behavior" if it means editing the keymap. I already said it, but it took me quite some time to find what caused my right Ctrl key to no longer work and fix it, and I think it's fair to consider myself a quite advanced user.

If really reverting the addition of Level5 is not an option (but see below), please add an alternative layout.

> 3. so far no one proposed any better option appart from removing symbols
> which are necessary to write proper French (arguably proper French is not
> the same as C code).

The change in this particular report did not add or remove any symbol, it only moved one to Level5 because some apps couldn't handle <Ctrl>Space with this layout. And as I said earlier, most of the incriminated apps (at least that I know of) don't even use <Ctrl>Space anymore, rendering the change moot for them.

And even if we wanted to please those apps, we mayb be able to without adding a new modifier (Level5) and a key for it -- again, see (comment #46).

Also note that event though I admittedly don't use short-nbsp (I'm afraid I don't know the rules where this one should be used in French typography), I'm an heavy user of nbsp everywhere French typography tells me to do it. So no, I don't want to remove anything, don't worry -- but I'd like my rig...

Read more...

(In reply to comment #70)

> If no agreement can be reached, would it be possible to have the old layout
> accessible, even under another name?

The old layout was never removed and kept its historical name (fr latin9)

(In reply to comment #72)
> The old layout was never removed and kept its historical name (fr latin9)

No, we are speaking here of fr/oss, but before it got right Ctrl as level5 modifier (what this bug end up changing).

I bet everyone complaining here was very happy with fr/oss before this Level5 modifier -- at least I was, this map has so everything useful (and more) on handy locations :)

(In reply to comment #71)

> And even if we wanted to please those apps, we mayb be able to without
> adding a new modifier (Level5) and a key for it -- again, see (comment #46).

I'm pretty sure some of the other spacebar configurations available as xkb options do not require level5. They are not the default for fr(oss) because without level5 it is too easy to type a nbspc by mistake and random nbspc everywhere breaks lots of things (as reported by fr latin9 users).

Nicolas,

Where does the need to *have* a key for nbsp come from? Isn't a compose combo more appropriate and less error-prone?

Cheers

(In reply to comment #75)
> Nicolas,
>
> Where does the need to *have* a key for nbsp come from?

Because unlike in English most French punctuation symbols require a space (sometimes a short space) before. And if it's not a non-breakable space apps will perform line breaks at the wrong position and you'll end up with orphan sumbols at line starts

Online
http://fr.wikipedia.org/wiki/Espace_ins%C3%A9cable

Actual authoritative reverence (highly recommended if you want to work on any system with French inputs or outputs)
http://www.amazon.fr/Lexique-r%C3%A8gles-typographiques-lImprimerie-Nationale/dp/2743304820

Lack of non breakspace on French layouts on some OSes is such a basic problem OpenOffice/LibreOffice had to hardcode a nbspc combo but that does not help when writing in you MUA, your browser, your IM client, etc

> Isn't a compose
> combo more appropriate and less error-prone?

Compose is not appropriate for basic symbols you need to write pretty much any correct sentence in the target language. And adding a specific input method for one symbol just because some people can't live with the modifier ISO chose for level 5 is disproportionnate.

(In reply to comment #76)
> Compose is not appropriate for basic symbols you need to write pretty much
> any correct sentence in the target language. And adding a specific input
> method for one symbol just because some people can't live with the modifier
> ISO chose for level 5 is disproportionnate.

Woow, calm down guys. What's disproportionate is the reaction here! *before* the change this report introduced, and which many of us are trying to get reverted, *both* nbsp and nbspc were easily available:

nbsp AltGr+Shift+Space
nbspc Ctrl+Shift+Space

Reverting the change this report introduced would get this behavior. Please understand we just want to get nbspc moved back where it *was* (or for me, anywhere on a 1-4 level), not removed or anything. Also, realize that currently there is only *one* Level5-specific symbol, and that's nbspc, so we basically have a key only for that.

However, for most French people, standard Right-Ctrl key is more important
than Nbsp.
Especially for left-handed people who use left hand for the mouse and most
letters, and right hand for Shift, Ctrl and AltGr. A notable exception is
Alt which only exists on the left.

Anyway, it's written Ctrl on the Right-Ctrl, so it MUST behave as a Ctrl.

Put nbsp where you want, but give us back the Right-Ctrl.

2014-05-07 11:41 GMT+02:00 Nicolas-mailhot-laposte <
<email address hidden>>:

> (In reply to comment #75)
> > Nicolas,
> >
> > Where does the need to *have* a key for nbsp come from?
>
> Because unlike in English most French punctuation symbols require a
> space (sometimes a short space) before. And if it's not a non-breakable
> space apps will perform line breaks at the wrong position and you'll end
> up with orphan sumbols at line starts
>
> Online
> http://fr.wikipedia.org/wiki/Espace_ins%C3%A9cable
>
> Actual authoritative reverence (highly recommended if you want to work on
> any system with French inputs or outputs)
>
> http://www.amazon.fr/Lexique-r%C3%A8gles-typographiques-lImprimerie-Nationale/dp/2743304820
>
> Lack of non breakspace on French layouts on some OSes is such a basic
> problem OpenOffice/LibreOffice had to hardcode a nbspc combo but that
> does not help when writing in you MUA, your browser, your IM client, etc
>
> > Isn't a compose
> > combo more appropriate and less error-prone?
>
> Compose is not appropriate for basic symbols you need to write pretty
> much any correct sentence in the target language. And adding a specific
> input method for one symbol just because some people can't live with the
> modifier ISO chose for level 5 is disproportionnate.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/xkeyboard-config/+bug/1013881/+subscriptions
>

What if nbsp is accessible using AltGr+Space or AltGt+Shift+Space ?

2014-05-07 14:00 GMT+02:00 Emmanuel Castro <email address hidden>:

> However, for most French people, standard Right-Ctrl key is more
> important than Nbsp.
> Especially for left-handed people who use left hand for the mouse and most
> letters, and right hand for Shift, Ctrl and AltGr. A notable exception is
> Alt which only exists on the left.
>
> Anyway, it's written Ctrl on the Right-Ctrl, so it MUST behave as a Ctrl.
>
> Put nbsp where you want, but give us back the Right-Ctrl.
>
>
> 2014-05-07 11:41 GMT+02:00 Nicolas-mailhot-laposte <
> <email address hidden>>:
>
> (In reply to comment #75)
>> > Nicolas,
>> >
>> > Where does the need to *have* a key for nbsp come from?
>>
>> Because unlike in English most French punctuation symbols require a
>> space (sometimes a short space) before. And if it's not a non-breakable
>> space apps will perform line breaks at the wrong position and you'll end
>> up with orphan sumbols at line starts
>>
>> Online
>> http://fr.wikipedia.org/wiki/Espace_ins%C3%A9cable
>>
>> Actual authoritative reverence (highly recommended if you want to work on
>> any system with French inputs or outputs)
>>
>> http://www.amazon.fr/Lexique-r%C3%A8gles-typographiques-lImprimerie-Nationale/dp/2743304820
>>
>> Lack of non breakspace on French layouts on some OSes is such a basic
>> problem OpenOffice/LibreOffice had to hardcode a nbspc combo but that
>> does not help when writing in you MUA, your browser, your IM client, etc
>>
>> > Isn't a compose
>> > combo more appropriate and less error-prone?
>>
>> Compose is not appropriate for basic symbols you need to write pretty
>> much any correct sentence in the target language. And adding a specific
>> input method for one symbol just because some people can't live with the
>> modifier ISO chose for level 5 is disproportionnate.
>>
>> --
>> You received this bug notification because you are subscribed to the bug
>> report.
>> https://bugs.launchpad.net/bugs/1013881
>>
>> Title:
>> Right-Ctrl key broken on French OSS keyboard
>>
>> To manage notifications about this bug go to:
>> https://bugs.launchpad.net/xkeyboard-config/+bug/1013881/+subscriptions
>>
>
>

JC Boggio (jissouille) wrote :

Please give us our Right Ctrl key back. Forcing everyone to make his own .Xmodmap to bypass the bug *is* the disproportionnate thing IMO.

I'm at a loss as to what to do to help find a solution for everyone.

fr-oss is a great layout with many useful improvements over fr-latin9, but the missing ControlR is a deal breaker. I'm personally back to using the default "fr" layout and I'll advise users to do the same if they want their ControlR back.

@Ubuntu users listening in through Launchpad: use whatever control panel you have to select a layout that doesn't have the words "Alternative" or "variante".

Cheers

Created attachment 98826
Make Level 5 choosers more easily available

The patch makes existing options for Level 5 choosers more easily available by adding them to the rules. This is useful in its own right, irrespective of this bug. In context of this ongoing discussion, it would allow to change back to the old default, and allow users who prefer the current behaviour to use the options lv5:rctrl_switch and nbsp:level4n to get their preferred behaviour.

About a "short nbsp" in french, let's make it perfectly clear that there must be about a hundred professionnal typographists in the whole country who care about it - most of them not using Linux BTW - and the rest of the ~40 million computer users here don't give a shit about a "short nbsp" and don't even know what it is, feel perfectly happy with the "correct french" they write without it, and many of them just would like their fscking right [Ctrl] key back.

If a so thin minority of professional typographists that in no way represent the average french "Joe" user want this modifier, it's perfectly OK that they devise their own special layout for their on needs, but by no means impose it on the rest of us.

You're kidding ! In France, professional typographists use Macintosh, I
fear. And the average French user is not "Joe", he's "Jean".

And I'll write unconstructive sarcasms until I get my Right-Ctrl back ! (Do
note the French style space before the exclamation marks)
Le 12 mai 2014 07:10, "Swâmi Petaramesh" <email address hidden> a
écrit :

> About a "short nbsp" in french, let's make it perfectly clear that there
> must be about a hundred professionnal typographists in the whole country
> who care about it - most of them not using Linux BTW - and the rest of
> the ~40 million computer users here don't give a shit about a "short
> nbsp" and don't even know what it is, feel perfectly happy with the
> "correct french" they write without it, and many of them just would like
> their fscking right [Ctrl] key back.
>
> If a so thin minority of professional typographists that in no way
> represent the average french "Joe" user want this modifier, it's
> perfectly OK that they devise their own special layout for their on
> needs, but by no means impose it on the rest of us.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1013881
>
> Title:
> Right-Ctrl key broken on French OSS keyboard
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/xkeyboard-config/+bug/1013881/+subscriptions
>

BTW, about the punctuation signs that, in French, requires a nbsp before them, i.e. " ; : ! ? " (for perfect typographic correctness, while usually few people know about this and nobody really cares...) :

Usual word processing programs, such as OpenOffice / LibreOffice, when configured to the french locale, add these typographically required nbsps automagically, so people actually do not have to type the nbsp, which makes the need for an easy entry of these still less of an issue.

Should we follow the slope of stealing a useful right [Ctrl] key for this, then me might well in the future steal the left one for the dash " - ", as in french, we typographically use at least 3 different lenghts for dashes. As previously, word processing software usually transforms the "normal dash" into the "typographically correct dash"... Nope, all this mess of quite complex and unusual characters is the very reason for which meta and compose keys exist in the first place...

Swâmi,

We've all laid out these arguments many times over. Yes, this issue is frustrating (and I regret having vented some of my own frustration in my first comments) but let's keep it civil.

There are proposed solutions. I, for one, think Andreas' proposal is the best way out of the current dead lock as it would allow each and everyone of us to configure the fr-oss layout the way we want it. It's now up to Sergey and Nicolas to decide how to move this forward.

Cheers

I too believe that Andreas' proposal is the right one. It permits people who really want the extra 5th level to be able to easily get it, while not breaking the 99% usual usage.

Just for the record, I had not seen the linuxfr discussion. I guess mostly only people who would want the extra 5th level did realize that it would steal the right control key. If a discussion happened on "are people fine with making the right control key the 5th level modifier by *default*", the result would be quite different, I believe.

At the risk of just making things worse ...

My €0.02 is that we should stick with level 5 right Control as being optional. This is a marginal (in terms of percentage of userbase that will ever see/use it) layout that people have to go out of their way to use, but still taking away a modifier is a pretty big and surprising step.

I've got sympathy with the non-breaking-space thing from a strict technical correctness point of view, however it just can't be essential for day-to-day usage if Windows requires you to enter it by the Unicode codepoint. If such a large percentage of the French-speaking world cope with it, then so can we.

I think Andreas's proposal is the only sensible one. Some people won't be happy with it, but if this discussion (and that of Bépo) has shown us anything, it's that you really can't please anyone when dealing with alternate French keyboard layouts.

Effede (dulaurier-f) wrote :

I don't believe this thread... Really, this is just unbelivable!

Nicolas, I don't know you, but you should seriously try to work on yourself and learn to accept when you're wrong.

For the virtual poll here, I say : PUT BACK THE CRTL-R KEY.

FWIW after user complaints I've reverted this change in Debian's xkeyboard-config, to have right control behave normally again.

ok, Daniel and Julien put last two nails into that coffin. I removed right control as level5 modifier in git. Thank you everybody. Really sorry there is no perfect solution here...

Changed in xkeyboard-config:
status: Confirmed → Fix Released

Hi,

Any chance to see this bug fixed in Trusty too?

As Trusty Tahr is a LTS edition, it should include the bug resolution so that it won't last for years.

Sebastien Bacher (seb128) wrote :

it would be nice to have a bug we can use for the SRU, not sure if that one is appropriate since it's years old and close. Otherwise agreed that we should fix that issue in trusty

Sebastien Bacher a écrit ce qui suit, le 23/07/14 12:10 :
> it would be nice to have a bug we can use for the SRU, not sure if that
> one is appropriate since it's years old and close. Otherwise agreed that
> we should fix that issue in trusty
>
In the Debian sid package xkb-data 2.12-1, the bug *is* corrected
(Ubuntu is still at 2.10). I did install it in 14.04 and test with the
Belgian alternate keyboard (based on the French). Both Ctrl keys do act
as Ctrl.
I do not understand the thing that would be nice to have above, but it
is not an issue any more for Debian testing or for Debian unstable.

@Dominique Meèus : how did you install xkb-data 2.12-1 in Trusty ? I've downloaded the .deb from https://packages.debian.org/sid/all/xkb-data/download but gdebi says : État : Erreur : n'est plus fourni xkb-data
I've tried through "Logithèque" which seems to install it (no error message) but still no classic right control key even after rebooting.
I'm using keyboard : Français (variante) and the keymap still shows "level 5…" under Right Ctrl key.

the fix looks like it'll reintroduce some form of #9529? or was the use of level4n instead of level4nl intentional?

I also noticed actual versions of xkb-data & xkb-data-i18n in Ubuntu 14.04.4/5 broke again right-ctrl-key with french ( alternative ) keyboard.

I've fixed it installing versions from xenial, using dpkg command.

http://packages.ubuntu.com/xenial/xkb-data
http://packages.ubuntu.com/xenial/xkb-data-i18n

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.